// --------------------------------------------------------------------
// Copyright (c) 2009 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//
//                                  QB3H/GEN/Port/Pin_Assign/2009/05/27        
// --------------------------------------------------------------------  
// 
// Button[3]: swich build-in test patter for DVI-TX
// Button[2]: toggle internal rx-tx loopback mode and tx-only mode
// Button[1]: write EEPROM EDID (Please remove the calbe at DVI-RX Port when update EEPROM EDID)
// LED[3:0]:
//	- blink: EEPROM EDID updating
//  - all lighten: loopback mode active
//  - other: pattern id in tx-only mode.


`include "vpg_source/vpg.h"

`define COLOR_RGB444	0

module DVI_Demo(

	// Global clock & reset
	clkin_50,
	cpu_resetn,
	
	// led, push-button
	user_led,          
	user_pb,
   user_dipsw,

	//////////// DDR2 //////////
	ddr2bot_a,
	ddr2bot_ba,
	ddr2bot_casn,
	ddr2bot_cke,
	ddr2_ck_n,
	ddr2_ck_p,
	ddr2bot_csn,
	ddr2_dm,
	ddr2_dq,
	ddr2_dqs,
	ddr2bot_rasn,
	ddr2bot_wen,
	ddr2bot_odt,
					 
	//////////// LCD //////////
	lcd_wen,
	lcd_data,
	lcd_en,
	lcd_d_cn,
	
	// DVI TX/RX BOARD Pin Name
	DVI_RX_CLK,
	DVI_RX_CTL,
	DVI_RX_DDCSCL,
	DVI_RX_DDCSDA,
	DVI_RX_DE,
	DVI_RX_D,
	DVI_RX_HS,
	DVI_RX_SCDT,
	DVI_RX_VS,
	
	DVI_TX_CLK,
	DVI_TX_CTL,
	DVI_TX_DDCSCL,
	DVI_TX_DDCSDA,
	DVI_TX_DE,
	DVI_TX_DKEN,
	DVI_TX_D,
	DVI_TX_HS,
	DVI_TX_HTPLG,
	DVI_TX_ISEL,
	DVI_TX_MSEN,
	DVI_TX_SCL,
	DVI_TX_SDA,
	DVI_TX_VS,
	EDID_WP,
	HSMC_SCL,
	HSMC_SDA,
	TX_PD_N,
	
	//////////// HSMC, HSMC connect to AHA - Aptina Head-Board Adaptor //////////
//	BUF_HISPI_CLK0_EN,
//	BUF_HISPI_DATA0_EN,
//	BUF_HISPI_DATA1_EN,
//	BUF_HISPI_DATA2_EN,
//	BUF_HISPI_DATA3_EN,
	CK_FPGA_MCLK,
	CK_IMG_IN_PIXCLK,
//	CK_LVDS_CLK0_n,
//	CK_LVDS_CLK0_p,
	DEMO2_I2C_SCL,
	DEMO2_I2C_SDA,
	IMG_DIN,
	IMG_IN_FV,
	IMG_IN_LV,
//	LVDS_DATA_n,
//	LVDS_DATA_p,
	SENSOR_RST,
	SHUTTER);

//=======================================================
//  PARAMETER declarations
//=======================================================

//=======================================================
//  PORT declarations
//=======================================================
// Global clock & reset
input           clkin_50;
input           cpu_resetn;

// led, push-button
output  [ 7: 0] user_led;  
input   [ 7: 0] user_dipsw; 
input   [ 3: 0] user_pb;   

//////////// DDR2 //////////
output  [12: 0] ddr2bot_a;
output  [ 1: 0] ddr2bot_ba;
output          ddr2bot_casn;
output          ddr2bot_cke;
output          ddr2bot_odt;
inout   [ 2: 0] ddr2_ck_n;
inout   [ 2: 0] ddr2_ck_p;
output          ddr2bot_csn;
output  [ 1: 0] ddr2_dm;
inout   [15: 0] ddr2_dq;
inout   [ 1: 0] ddr2_dqs;
output          ddr2bot_rasn;
output          ddr2bot_wen;

//////////// LCD //////////
output          lcd_wen;
inout   [ 7: 0] lcd_data;
output          lcd_en;
output          lcd_d_cn;

// DVI TX/RX BOARD Pin Declare
input	          DVI_RX_CLK;
input	  [ 3: 1] DVI_RX_CTL;
inout	          DVI_RX_DDCSCL;
inout           DVI_RX_DDCSDA;
input           DVI_RX_DE;
input   [23: 0] DVI_RX_D;
input           DVI_RX_HS;
input           DVI_RX_SCDT;
input           DVI_RX_VS;

output  [ 3: 1] DVI_TX_CTL;
output          DVI_TX_DKEN;
output  [23: 0] DVI_TX_D;

inout	          DVI_TX_DDCSCL;
inout	          DVI_TX_DDCSDA;

output          DVI_TX_CLK;
output          DVI_TX_DE;
output          DVI_TX_VS;
output          DVI_TX_HS;

output          DVI_TX_HTPLG;
output          DVI_TX_ISEL;
output          DVI_TX_MSEN;
output          DVI_TX_SCL;

inout           DVI_TX_SDA;
output          EDID_WP;

output          HSMC_SCL;
inout           HSMC_SDA;

output          TX_PD_N;

//////////// HSMC, HSMC connect to AHA - Aptina Head-Board Adaptor //////////
//output          BUF_HISPI_CLK0_EN;
//output          BUF_HISPI_DATA0_EN;
//output          BUF_HISPI_DATA1_EN;
//output          BUF_HISPI_DATA2_EN;
//output          BUF_HISPI_DATA3_EN;
output          CK_FPGA_MCLK;
input           CK_IMG_IN_PIXCLK;
//input           CK_LVDS_CLK0_n;
//input           CK_LVDS_CLK0_p;
output          DEMO2_I2C_SCL;
inout           DEMO2_I2C_SDA;
input   [11: 0] IMG_DIN;
input           IMG_IN_FV;
input           IMG_IN_LV;
//input 		     [ 3: 0] LVDS_DATA_n;
//input 		     [ 3: 0] LVDS_DATA_p;
output          SENSOR_RST;  //??? CHANGE TO SENSOR_RST_BAR?
output          SHUTTER;

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire clk_vip;
wire clk_40;
wire clk_camera;
wire reset_n;
wire camera_reset_n;

//=======================================================
//  Structural coding
//=======================================================

//----------------------------------------------//
// 			 DVI TX                 	  	   	//
//----------------------------------------------//
//=============== DVI TX CONFIG ==================
assign DVI_TX_ISEL 	= 1'b0; 	// disable i2c
assign DVI_TX_SCL 	= 1'b1; 	// BSEL=0, 12-bit, dual-edge input
assign DVI_TX_HTPLG  = 1'b1; 	// Note. *** EDGE=1, primary latch to occur on the rising edge of the input clock IDCK+
assign DVI_TX_SDA 	= 1'b1;  // DSEL=X (VREF=3.3V)
assign TX_PD_N       = 1'b1;

assign DVI_TX_CLK = !clk_40;
assign reset_n = 1'b1;

// AHA
assign SENSOR_RST = camera_reset_n;
assign CK_FPGA_MCLK = clk_camera;
assign SHUTTER = user_pb[3];

VIP_SOPC VIP_SOPC_inst(
                  // 1) global signals:
                   .altmemddr2_aux_full_rate_clk_out       (),
                   .altmemddr2_aux_half_rate_clk_out       (),
                   .altmemddr2_phy_clk_out                 (),

                   .altpll_camera                          (clk_camera),
                   .altpll_io                              (),
                   .altpll_sys                             (),
                   .altpll_vga                             (clk_40),

                   .clk_50                                 (clkin_50),
                   .reset_n                                (reset_n),

                  // the_alt_vip_itc
                   .underflow_from_the_alt_vip_itc         (),
                   .vid_clk_to_the_alt_vip_itc             (DVI_TX_CLK),
                   .vid_data_from_the_alt_vip_itc          ({DVI_TX_D[7:0],DVI_TX_D[15:8],DVI_TX_D[23:16]}),
                   .vid_datavalid_from_the_alt_vip_itc     (DVI_TX_DE),
                   .vid_f_from_the_alt_vip_itc             (),
                   .vid_h_from_the_alt_vip_itc             (),
                   .vid_h_sync_from_the_alt_vip_itc        (DVI_TX_HS),
                   .vid_v_from_the_alt_vip_itc             (),
                   .vid_v_sync_from_the_alt_vip_itc        (DVI_TX_VS),

                  // the_altmemddr2
                   .global_reset_n_to_the_altmemddr2       (cpu_resetn),
                   .local_init_done_from_the_altmemddr2    (),
                   .local_refresh_ack_from_the_altmemddr2  (),
                   .local_wdata_req_from_the_altmemddr2    (),

                   .mem_addr_from_the_altmemddr2           (ddr2bot_a),
                   .mem_ba_from_the_altmemddr2             (ddr2bot_ba),
                   .mem_cas_n_from_the_altmemddr2          (ddr2bot_casn),
                   .mem_cke_from_the_altmemddr2            (ddr2bot_cke),
                   .mem_clk_n_to_and_from_the_altmemddr2   (ddr2_ck_n),
                   .mem_clk_to_and_from_the_altmemddr2     (ddr2_ck_p),
                   .mem_cs_n_from_the_altmemddr2           (ddr2bot_csn),
                   .mem_dm_from_the_altmemddr2             (ddr2_dm),
                   .mem_dq_to_and_from_the_altmemddr2      (ddr2_dq),
                   .mem_dqs_to_and_from_the_altmemddr2     (ddr2_dqs),
                   .mem_odt_from_the_altmemddr2            (ddr2bot_odt),
                   .mem_ras_n_from_the_altmemddr2          (ddr2bot_rasn),
                   .mem_we_n_from_the_altmemddr2           (ddr2bot_wen),
                   .reset_phy_clk_n_from_the_altmemddr2    (),

                  // the_altpll_sys
                   .c4_from_the_altpll_sys                 (),
                   .locked_from_the_altpll_sys             (),
                   .phasedone_from_the_altpll_sys          (),

                  // the_camera
                   .CAMERA_D_to_the_camera                 (IMG_DIN),
                   .CAMERA_FVAL_to_the_camera              (IMG_IN_FV),
                   .CAMERA_LVAL_to_the_camera              (IMG_IN_LV),
                   .CAMERA_PIXCLK_to_the_camera            (CK_IMG_IN_PIXCLK),

                  // the_camera_reset_n
                   .out_port_from_the_camera_reset_n       (camera_reset_n),

                  // the_camera_scl
                   .out_port_from_the_camera_scl           (DEMO2_I2C_SCL),

                  // the_camera_sda
                   .bidir_port_to_and_from_the_camera_sda  (DEMO2_I2C_SDA),

                  // the_camera_strobe
                   .in_port_to_the_camera_strobe           (CAMERA_STROBE),

                  // the_camera_trigger
                   .out_port_from_the_camera_trigger       (CAMERA_TRIGGER),
                  
						// the_lcd
                   .LCD_E_from_the_lcd                     (lcd_en),
                   .LCD_RS_from_the_lcd                    (lcd_d_cn),
                   .LCD_RW_from_the_lcd                    (lcd_wen),
                   .LCD_data_to_and_from_the_lcd           (lcd_data),

						// the_led
                   .out_port_from_the_led                  (user_led),

						// the_sw
                   .in_port_to_the_sw                      (user_dipsw),
						 
                  // the_user_pb
                   .in_port_to_the_user_pb                 (user_pb)
);

endmodule